/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// RelatedProductOrderItem RelatedProductOrderItem (ProductOrder item) .The product order item which triggered product creation/change/termination.
type RelatedProductOrderItem struct {
	// Action of the order item for this product
	OrderItemAction *string `json:"orderItemAction,omitempty"`
	// Identifier of the order item where the product was managed
	OrderItemId string `json:"orderItemId"`
	// Reference of the related entity.
	ProductOrderHref *string `json:"productOrderHref,omitempty"`
	// Unique identifier of a related entity.
	ProductOrderId string `json:"productOrderId"`
	// role of the product order item for this product
	Role *string `json:"role,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
	// The actual type of the target instance when needed for disambiguation.
	ReferredType *string `json:"@referredType,omitempty"`
}

// NewRelatedProductOrderItem instantiates a new RelatedProductOrderItem object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewRelatedProductOrderItem(orderItemId string, productOrderId string, ) *RelatedProductOrderItem {
	this := RelatedProductOrderItem{}
	this.OrderItemId = orderItemId
	this.ProductOrderId = productOrderId
	return &this
}

// NewRelatedProductOrderItemWithDefaults instantiates a new RelatedProductOrderItem object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewRelatedProductOrderItemWithDefaults() *RelatedProductOrderItem {
	this := RelatedProductOrderItem{}
	return &this
}

// GetOrderItemAction returns the OrderItemAction field value if set, zero value otherwise.
func (o *RelatedProductOrderItem) GetOrderItemAction() string {
	if o == nil || o.OrderItemAction == nil {
		var ret string
		return ret
	}
	return *o.OrderItemAction
}

// GetOrderItemActionOk returns a tuple with the OrderItemAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetOrderItemActionOk() (*string, bool) {
	if o == nil || o.OrderItemAction == nil {
		return nil, false
	}
	return o.OrderItemAction, true
}

// HasOrderItemAction returns a boolean if a field has been set.
func (o *RelatedProductOrderItem) HasOrderItemAction() bool {
	if o != nil && o.OrderItemAction != nil {
		return true
	}

	return false
}

// SetOrderItemAction gets a reference to the given string and assigns it to the OrderItemAction field.
func (o *RelatedProductOrderItem) SetOrderItemAction(v string) {
	o.OrderItemAction = &v
}

// GetOrderItemId returns the OrderItemId field value
func (o *RelatedProductOrderItem) GetOrderItemId() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.OrderItemId
}

// GetOrderItemIdOk returns a tuple with the OrderItemId field value
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetOrderItemIdOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.OrderItemId, true
}

// SetOrderItemId sets field value
func (o *RelatedProductOrderItem) SetOrderItemId(v string) {
	o.OrderItemId = v
}

// GetProductOrderHref returns the ProductOrderHref field value if set, zero value otherwise.
func (o *RelatedProductOrderItem) GetProductOrderHref() string {
	if o == nil || o.ProductOrderHref == nil {
		var ret string
		return ret
	}
	return *o.ProductOrderHref
}

// GetProductOrderHrefOk returns a tuple with the ProductOrderHref field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetProductOrderHrefOk() (*string, bool) {
	if o == nil || o.ProductOrderHref == nil {
		return nil, false
	}
	return o.ProductOrderHref, true
}

// HasProductOrderHref returns a boolean if a field has been set.
func (o *RelatedProductOrderItem) HasProductOrderHref() bool {
	if o != nil && o.ProductOrderHref != nil {
		return true
	}

	return false
}

// SetProductOrderHref gets a reference to the given string and assigns it to the ProductOrderHref field.
func (o *RelatedProductOrderItem) SetProductOrderHref(v string) {
	o.ProductOrderHref = &v
}

// GetProductOrderId returns the ProductOrderId field value
func (o *RelatedProductOrderItem) GetProductOrderId() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.ProductOrderId
}

// GetProductOrderIdOk returns a tuple with the ProductOrderId field value
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetProductOrderIdOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.ProductOrderId, true
}

// SetProductOrderId sets field value
func (o *RelatedProductOrderItem) SetProductOrderId(v string) {
	o.ProductOrderId = v
}

// GetRole returns the Role field value if set, zero value otherwise.
func (o *RelatedProductOrderItem) GetRole() string {
	if o == nil || o.Role == nil {
		var ret string
		return ret
	}
	return *o.Role
}

// GetRoleOk returns a tuple with the Role field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetRoleOk() (*string, bool) {
	if o == nil || o.Role == nil {
		return nil, false
	}
	return o.Role, true
}

// HasRole returns a boolean if a field has been set.
func (o *RelatedProductOrderItem) HasRole() bool {
	if o != nil && o.Role != nil {
		return true
	}

	return false
}

// SetRole gets a reference to the given string and assigns it to the Role field.
func (o *RelatedProductOrderItem) SetRole(v string) {
	o.Role = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *RelatedProductOrderItem) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *RelatedProductOrderItem) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *RelatedProductOrderItem) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *RelatedProductOrderItem) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *RelatedProductOrderItem) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *RelatedProductOrderItem) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *RelatedProductOrderItem) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *RelatedProductOrderItem) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *RelatedProductOrderItem) SetType(v string) {
	o.Type = &v
}

// GetReferredType returns the ReferredType field value if set, zero value otherwise.
func (o *RelatedProductOrderItem) GetReferredType() string {
	if o == nil || o.ReferredType == nil {
		var ret string
		return ret
	}
	return *o.ReferredType
}

// GetReferredTypeOk returns a tuple with the ReferredType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *RelatedProductOrderItem) GetReferredTypeOk() (*string, bool) {
	if o == nil || o.ReferredType == nil {
		return nil, false
	}
	return o.ReferredType, true
}

// HasReferredType returns a boolean if a field has been set.
func (o *RelatedProductOrderItem) HasReferredType() bool {
	if o != nil && o.ReferredType != nil {
		return true
	}

	return false
}

// SetReferredType gets a reference to the given string and assigns it to the ReferredType field.
func (o *RelatedProductOrderItem) SetReferredType(v string) {
	o.ReferredType = &v
}

func (o RelatedProductOrderItem) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.OrderItemAction != nil {
		toSerialize["orderItemAction"] = o.OrderItemAction
	}
	if true {
		toSerialize["orderItemId"] = o.OrderItemId
	}
	if o.ProductOrderHref != nil {
		toSerialize["productOrderHref"] = o.ProductOrderHref
	}
	if true {
		toSerialize["productOrderId"] = o.ProductOrderId
	}
	if o.Role != nil {
		toSerialize["role"] = o.Role
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	if o.ReferredType != nil {
		toSerialize["@referredType"] = o.ReferredType
	}
	return json.Marshal(toSerialize)
}

type NullableRelatedProductOrderItem struct {
	value *RelatedProductOrderItem
	isSet bool
}

func (v NullableRelatedProductOrderItem) Get() *RelatedProductOrderItem {
	return v.value
}

func (v *NullableRelatedProductOrderItem) Set(val *RelatedProductOrderItem) {
	v.value = val
	v.isSet = true
}

func (v NullableRelatedProductOrderItem) IsSet() bool {
	return v.isSet
}

func (v *NullableRelatedProductOrderItem) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableRelatedProductOrderItem(val *RelatedProductOrderItem) *NullableRelatedProductOrderItem {
	return &NullableRelatedProductOrderItem{value: val, isSet: true}
}

func (v NullableRelatedProductOrderItem) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableRelatedProductOrderItem) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


